﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;
using System.Windows.Media.Effects;
using Infragistics.Windows;
using System.Diagnostics;
using Infragistics.Windows.Editors;

namespace DragRecordsXDG
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    /// 

    public partial class MainWindow : Window
    {

        BindingList<Employee> data;
        public MainWindow()
        {
            InitializeComponent();
            data = EmployeeData.GenerateEmployeeData();
            xamDataGrid1.DataSource = data;
        }
      

        private void DragSource_Drop(object sender, Infragistics.DragDrop.DropEventArgs e)
        {
            Debug.WriteLine("curr " + currentIndex);
            Debug.WriteLine("over " + overIndex);
            Employee emp = new Employee();
            emp = dp.DataRecord.DataItem as Employee;

            data.Remove(emp);
            data.Insert(overIndex, emp);
        }

        DataRecordPresenter dp;
        DataRecordPresenter dragOver;
        int currentIndex;
        private void DragSource_DragStart(object sender, Infragistics.DragDrop.DragDropStartEventArgs e)
        {
           dp= Utilities.GetAncestorFromType(e.DragSource as DependencyObject, typeof(DataRecordPresenter), false) as DataRecordPresenter;
           currentIndex = dp.Record.Index;

        }

        private void CardPanel_MouseDown(object sender, MouseButtonEventArgs e)
        {
            e.Handled = true;
            //XamTextEditor editor = Utilities.GetDescendantFromType(sender as DependencyObject, typeof(XamTextEditor), false) as XamTextEditor;
            //editor.EditModeStarting += new EventHandler<Infragistics.Windows.Editors.Events.EditModeStartingEventArgs>(editor_EditModeStarting);
        }

        void editor_EditModeStarting(object sender, Infragistics.Windows.Editors.Events.EditModeStartingEventArgs e)
        {
            
        }
        int overIndex;
        private void DragSource_DragOver(object sender, Infragistics.DragDrop.DragDropMoveEventArgs e)
        {
            dragOver = Utilities.GetAncestorFromType(e.DropTarget as DependencyObject, typeof(DataRecordPresenter), false) as DataRecordPresenter;
            overIndex = dragOver.Record.VisibleIndex;

        }

        private void xamDataGrid1_InitializeRecordDirect(object sender, Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs e)
        {

            //if( e.Record.FieldLayout.Fields[0].Name.ToString() == "IOSequenceNumber")
            e.Record.RefreshSortPosition();

        }

        private void xamDataGrid1_AssigningFieldLayoutToItem(object sender, Infragistics.Windows.DataPresenter.Events.AssigningFieldLayoutToItemEventArgs e)
        {


            FieldLayout resultLayout = new FieldLayout();

            //if (e.ParentExpandableFieldRecord == null)
            //    resultLayout = xamDataGrid1.FieldLayouts["IOcomponents"];
            //else
            //    resultLayout = xamDataGrid1.FieldLayouts["child"];

            //e.FieldLayout = resultLayout;
        }

        private void DragSource_DragEnd(object sender, Infragistics.DragDrop.DragDropEventArgs e)
        {

        }
    }
}
